// Decompiled by DJ v3.11.11.95 Copyright 2009 Atanas Neshkov  Date: 9. 6. 2011 13:17:28
// Home Page: http://members.fortunecity.com/neshkov/dj.html  http://www.neshkov.com/dj.html - Check often for new version!
// Decompiler options: packimports(3) 
// Source File Name:   PropertyLoader.java

package sk.lacike.jira;

import com.atlassian.core.util.ClassLoaderUtils;
import java.io.*;
import java.net.URL;
import java.util.Hashtable;
import java.util.Properties;
import org.apache.log4j.Logger;

public class PropertyLoader
{
    private static final Logger log = Logger.getLogger(sk.lacike.jira.PropertyLoader.class);
    protected Hashtable propertiesCache;

    public PropertyLoader()
    {
        propertiesCache = new Hashtable();
    }

    public String getCacheString(Class cls, String filename)
    {
        if(filename == null || filename.trim().isEmpty())
            return cls.toString();
        else
            return (new StringBuilder(String.valueOf(cls.toString()))).append("-").append(filename).toString();
    }

    public Properties loadDefault(String filename, Class cls)
    {
        String cacheString = getCacheString(cls, null);
        return loadOnce(filename, cls, cacheString);
    }

    public Properties loadFile(String filename, Class cls)
    {
        String cacheString = getCacheString(cls, filename);
        return loadOnce(filename, cls, cacheString);
    }

    protected Properties loadOnce(String filename, Class cls, String cacheString)
    {
        Properties properties = (Properties)propertiesCache.get(cacheString);
        if(properties == null)
            properties = load(filename, cls, cacheString);
        return properties;
    }

    protected Properties load(String filename, Class cls, String cacheString)
    {
        Properties properties;
        synchronized(propertiesCache)
        {
            properties = new Properties();
            try
            {
                log.debug((new StringBuilder("Loading properties from ")).append(filename).append(".properties").toString());
                InputStream stream = ClassLoaderUtils.getResourceAsStream((new StringBuilder(String.valueOf(filename))).append(".properties").toString(), cls);
                if(stream == null)
                {
                    log.debug((new StringBuilder("Unable to load properties as stream from ")).append(filename).toString());
                    URL resource = ClassLoaderUtils.getResource((new StringBuilder(String.valueOf(filename))).append(".properties").toString(), cls);
                    File propFile = new File(resource.getFile());
                    stream = new FileInputStream(propFile);
                } else
                {
                    log.debug((new StringBuilder("Success to load properties as stream from ")).append(filename).toString());
                }
                log.debug((new StringBuilder("Properties from ")).append(filename).append(" loaded succesfully").toString());
                properties.load(stream);
                stream.close();
                propertiesCache.put(cacheString, properties);
            }
            catch(IOException e)
            {
                log.error((new StringBuilder("Error loading property file ")).append(filename).toString(), e);
            }
        }
        return properties;
    }

    public String readDefault(Class cls, String property)
    {
        Properties properties = (Properties)propertiesCache.get(getCacheString(cls, null));
        return (String)properties.get(property);
    }

    public String readFile(Class cls, String filename, String property)
    {
        Properties properties = (Properties)propertiesCache.get(getCacheString(cls, filename));
        return (String)properties.get(property);
    }

    public String readCacheString(String cacheString, String property)
    {
        Properties properties = (Properties)propertiesCache.get(cacheString);
        return (String)properties.get(property);
    }

    public String readDefault(Class cls, String property, String index)
    {
        return readDefault(cls, (new StringBuilder(String.valueOf(property))).append(".").append(index).toString());
    }

    public String readDefault(Class cls, String property, String index1, String index2)
    {
        return readDefault(cls, (new StringBuilder(String.valueOf(property))).append(".").append(index1).append(".").append(index2).toString());
    }
}
